#include "main.h"
// (C) 2006 Ingo Busker http://www.mikrocontroller.com

int GetValueAt( char *buffer, unsigned char stellen)
{
  buffer[stellen] = '\0';
  return( atoi(buffer));
}

char GetHexValueAt(char *buffer)
{
  unsigned char x;
  
  if (buffer[0]<'A') x = 16 * (buffer[0] - '0');
   else x = 16 * (buffer[0] - 'A'+ 10);
 
 if (buffer[1] < 'A') x += (buffer[1] - '0');
   else x +=  (buffer[1] - 'A' + 10);
   
  return(x);
  
}

void ReadConfigFile(void)
{
 #if USE_MMC 
 File fp;
 int c = 0;
	 
  printf_P(PSTR("reading 'server.cfg'..."));
  if(FileOpen( "server.cfg",'r', &fp))
  {
  
 while(FileGetString(packet, &fp, 80)) 
	 { 
	   
	   if ((memcmp(packet, "#", 1)==0) || (memcmp(packet, " ", 1)==0)) ;  // Kommentar oder Leerzeile
 	   else if (memcmp(packet, "IP=", 3)==0) 
	   {
          MYIP[0] = GetValueAt(packet+3,  3);
		  MYIP[1] = GetValueAt(packet+7,  3);
		  MYIP[2] = GetValueAt(packet+11, 3);
          MYIP[3] = GetValueAt(packet+15, 3);
	   }
	   else if (memcmp(packet, "MAC=", 4)==0) 
	   {
	      mymac[0] = GetHexValueAt(packet+4);
		  mymac[1] = GetHexValueAt(packet+7);
		  mymac[2] = GetHexValueAt(packet+10);
          mymac[3] = GetHexValueAt(packet+13);
		  mymac[4] = GetHexValueAt(packet+16);
          mymac[5] = GetHexValueAt(packet+19);
	   }
	   else if (memcmp(packet, "NTP=", 4)==0) 
	   {
	      ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Byte[0] = GetValueAt(packet+4,  3);
		  ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Byte[1] = GetValueAt(packet+8,  3);
		  ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Byte[2] = GetValueAt(packet+12, 3);
          ARP_Table[ARP_TABLE_ENTRY_NTPSERVER].IP.Byte[3] = GetValueAt(packet+16, 3);
	   }
	   else if (memcmp(packet, "FTP=", 4)==0) 
	   {
          ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Byte[0] = GetValueAt(packet+4,  3);
		  ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Byte[1] = GetValueAt(packet+8,  3);
		  ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Byte[2] = GetValueAt(packet+12, 3);
          ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Byte[3] = GetValueAt(packet+16, 3);
	   }
	   else if (memcmp(packet, "SMTP=", 5)==0) 
	   {
          ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Byte[0] = GetValueAt(packet+5,  3);
		  ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Byte[1] = GetValueAt(packet+9,  3);
		  ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Byte[2] = GetValueAt(packet+13, 3);
          ARP_Table[ARP_TABLE_ENTRY_SMTPSERVER].IP.Byte[3] = GetValueAt(packet+17, 3);
	   }
	   else if (memcmp(packet, "ROUTER=", 7)==0) 
	   {
          ARP_Table[ARP_TABLE_ENTRY_ROUTER].IP.Byte[0] = GetValueAt(packet+7,  3);
		  ARP_Table[ARP_TABLE_ENTRY_ROUTER].IP.Byte[1] = GetValueAt(packet+11,  3);
		  ARP_Table[ARP_TABLE_ENTRY_ROUTER].IP.Byte[2] = GetValueAt(packet+15, 3);
          ARP_Table[ARP_TABLE_ENTRY_ROUTER].IP.Byte[3] = GetValueAt(packet+19, 3);
	   }
	   else if (memcmp(packet, "SMTP_AUTH_LOGIN=", 16)==0)     { SMTP_AuthLogin = (packet[16] == 'Y') ? 1 : 0; }
	   else if (memcmp(packet, "MAIL_TRIGGER=", 13)==0)        { Mail_Trigger_Enable = (packet[13] == 'Y') ? 1 : 0; }
	   else if (memcmp(packet, "NTP_ENABLE=", 11)==0)          { NTP_Enable = (packet[11] == 'Y') ? 1 : 0; }
	   else if (memcmp(packet, "CAM_ENABLE=", 11)==0)          { CAM_Enable = (packet[11] == 'Y') ? 1 : 0; }
	   else if (memcmp(packet, "CAM_STORE_ENABLE=", 17)==0)    { CAM_SD_Store_Enable = (packet[17] == 'Y') ? 1 : 0; }
	   else if (memcmp(packet, "FTP_PUSH_ENABLE=", 16)==0)     { FTP_Push_Enable = (packet[16] == 'Y') ? 1 : 0; }
	   else if (memcmp(packet, "CAM_STORE_TIME=", 15)==0)      { CAM_SD_Store_Time = GetValueAt(packet+15,  4); }
	   else if (memcmp(packet, "FTP_USER=", 9)==0) 			   { sprintf(FTP_Username,"%s\0", &packet[9]);}
	   else if (memcmp(packet, "FTP_PASS=", 9)==0)             { sprintf(FTP_Password,"%s\0", &packet[9]); }
	   else if (memcmp(packet, "SMTP_USER=", 10)==0)           { sprintf(SMTP_Username,"%s\0", &packet[10]); }
	   else if (memcmp(packet, "SMTP_PASS=", 10)==0)           { sprintf(SMTP_Password,"%s\0", &packet[10]); }
	   else if (memcmp(packet, "EXT_TRIG_ENABLE=", 16)==0)     { vars.type_char[EXT_TRIGGER_ADDR] |= (packet[16] == 'Y') ? EXT_TRIGGER_ENABLED : 0; }
	   else if (memcmp(packet, "EXT_TRIG_STATE=", 15)==0)      { vars.type_char[EXT_TRIGGER_ADDR] |= (packet[15] == 'H') ? EXT_TRIGGER_STATE : 0; }
	   else if (memcmp(packet, "EXT_TRIG_TIME=", 14)==0)       { vars.type_int[EXT_TRIGGER_TIME_ADDR] = GetValueAt(packet+14,  4); }
	   else if (memcmp(packet, "EXT_TRIG_PIN=", 13)==0)        { vars.type_int[EXT_TRIGGER_PIN_ADDR]  = GetValueAt(packet+13,  2); }
	   
    }
    FileClose(&fp);
	  
    printf_P(PSTR("Ok\n\r"));  
    

  }
  else printf_P(PSTR("not found!\n\rUse default configuration\n\r"));  
#endif	

}
