// (C) 2006 Ingo Busker http://www.mikrocontroller.com
#include "main.h"
#include "ftpclient.h"
#include "socket.h"

#if USE_FTPC

PROGMEM char FTP_USER[] = "USER "; 
PROGMEM char FTP_PASS[] = "PASS ";
PROGMEM char FTP_SYST[] = "SYST\r\n";
PROGMEM char FTP_PWD[]  = "PWD\r\n"; 
PROGMEM char FTP_PORT[] = "PORT "; 
PROGMEM char FTP_TYPE[] = "TYPE I\r\n";
PROGMEM char FTP_STOR[] = "STOR ";
PROGMEM char FTP_QUIT[] = "QUIT\r\n";

#define BLOCK_SIZE BlockSize // aus fat.h

unsigned char FTP_transfer_completed;
unsigned char FTP_Username[9]="ingo\0\0\0\0\0";
unsigned char FTP_Password[9]="test\0\0\0\0\0";


void ftpc(char* buffer, int *bufferlen) {
	unsigned int tcpdata;
	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
    
	//Verwaltung Stackpointer
	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack(buffer,bufferlen,&a) == 1) return; //keine Daten fr Anwendung
	tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
    
	//berprft daten
	if (tcp_socket->Status == TCP_SOCKET_OPEN1) {
		unsigned char data = ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0); // wenn daten zu lesen sind
		unsigned int code;
		unsigned int i = 0;

		if (data) {
			buffer[tcpdata+3] = '\0';
			code = atoi(buffer+tcpdata);
		} else {
			code = -1;
		}
		//printf("FTP(%u),stage(%u)\n", code, tcp_socket->CommStage);

		tcp_store(buffer);	
		//Setzen des Ack Flags und PSH Flags	
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG;

		if ((!data) || (code < 500)) {
			switch (tcp_socket->CommStage) {
			case 0:
				if (data) {
					i = sprintf_P(buffer+tcpdata, FTP_USER);
					i+= sprintf(buffer+tcpdata+i, FTP_Username);
					sprintf_P(buffer+tcpdata+i, PSTR("\r\n"));
					i+=2;
					tcp_socket->CommStage++;
					FTP_transfer_completed = 1;
		
				}
				break;
			case 1:
				if (data) {
					i = sprintf_P(buffer+tcpdata, FTP_PASS);
					i+= sprintf(buffer+tcpdata+i, FTP_Password);
					sprintf_P(buffer+tcpdata+i, PSTR("\r\n"));
					i+=2;
					tcp_socket->CommStage++;
				}
				
				break;
			case 2:
				if (data) {
					i = sprintf_P(buffer+tcpdata, FTP_TYPE);
					tcp_socket->CommStage++;
				}
				break;
			case 3:
				if (data) {
					i = sprintf_P(buffer+tcpdata, FTP_PORT);
					i+= sprintf(buffer+tcpdata+i, "%d,%d,%d,%d,4,4", MYIP[0], MYIP[1], MYIP[2], MYIP[3]);	
					sprintf_P(buffer+tcpdata+i, PSTR("\r\n"));
					i+=2;
					tcp_socket->CommStage++;
				}
				break;
			case 4:
				if (data) {
				    struct time t;
					gettime(ActualTime, &t);
					i = sprintf_P(buffer+tcpdata, FTP_STOR);
					i+= sprintf(buffer+tcpdata+i, "%04d%02d%02d_%02d%02d.JPG", t.year,t.month, t.day, t.hour, t.minute); 
					sprintf_P(buffer+tcpdata+i, PSTR("\r\n"));
					i+=2;
					tcp_socket->CommStage++;
					FTP_transfer_completed = 0;
					mca25_cam_status = MCA25_FIRST_DATA;
				}
				break;
			case 5:
				if(FTP_transfer_completed && data)
				   {
					i = sprintf_P(buffer+tcpdata, FTP_QUIT);
					tcp_socket->CommStage = 6;
					
				   }   
					
				break;
			default:
				i = 0;
				if (data) {
					//i = sprintf_P(buffer+tcpdata, FTP_QUIT);
					//tcp_socket->CommStage++;
				}
				break;
			}
		} else {
			// fehler. quit senden, commstage setzen, da es nicht mehr oben greift
			printf("FTPErr(%u)\n\r", code);
			i = sprintf_P(buffer+tcpdata, FTP_QUIT);
			tcp_socket->CommStage = 6;
		}

		TCP_New_Packtlen(buffer, bufferlen, tcpdata + i);
		tcp_make(buffer);			
		Write_Ethernet_Frame (buffer,*bufferlen);	
		if (tcp_socket->CommStage == 5) delay_ms(100);
		if (tcp_socket->CommStage > 5) tcp_socket->Status = TCP_SOCKET_CLOSE;
	}
}

void ftp_store(char* buffer, int *bufferlen) {
	unsigned int tcpdata;
	
	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
    
	//Verwaltung Stackpointer
	unsigned char a;//Stack Speichplatz Default (0..10)
	if (TCP_Stack(buffer,bufferlen,&a) == 1) return; //keine Daten fr Anwendung
	tcp_socket = &tcpsockets[a]; //Pointer auf tcpsockets[a] holen
    //printf("ftp_data.");
	//berprft daten
	if (tcp_socket->Status == TCP_SOCKET_OPEN1) 
	{
		static unsigned int code = 0;
		unsigned char complete = 0;
		
	    tcp_store(buffer);	
	    
		if (!FTP_transfer_completed) 
		 { 
		   if (mca25_copy_image_data_to_tcp_buffer(buffer, bufferlen) ==1 ) complete = 0; else complete = 1; 
	       buffer[TCP_HDRFLAGS+1] = ACK_FLAG; 
		 }
    /*    else  
		 {
		  TCP_New_Packtlen(buffer, bufferlen, tcpdata + 0);
		  buffer[TCP_HDRFLAGS+1] = ACK_FLAG + FIN_FLAG; 
		 } */
		tcp_make(buffer);			
		
		Write_Ethernet_Frame (buffer,*bufferlen);
        
		//if( FTP_transfer_completed)tcp_socket->Status = TCP_SOCKET_CLOSE; 
		
		if (complete) { FTP_transfer_completed = 1; code = 0; tcp_socket->Status = TCP_SOCKET_CLOSE; }
		
	}
	
	
}


void ftp_connect(char *buffer, int bufferlen) {
	//Pointer auf Ethernet_Header
	struct Ethernet_Header *ethernet;
	ethernet = (struct Ethernet_Header *)&buffer[ETHER_OFFSET];
	//Pointer auf IP_Header
	struct IP_Header *ip;
	ip = (struct IP_Header *)&buffer[IP_OFFSET];
	//Pointer auf TCP_Header
	struct TCP_Header *tcp;
	tcp = (struct TCP_Header *)&buffer[TCP_OFFSET];

	unsigned int tcpdata;

	ethernet->EnetPacketType = 0x0008; // IP
	ip->IP_Proto = PROT_TCP; // TCP

	ip->IP_Srcaddr = ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].IP.Long;
	for (unsigned char a = 0; a < 6; a++) {
		ethernet->EnetPacketSrc[a] = ARP_Table[ARP_TABLE_ENTRY_FTPSERVER].ARP_MAC[a];
	}

	// FLAG FR UNFRAGMENTIERT SETZEN!
	// !> eigene routine: create_new_ip_header() oder so:
	ip->IP_Vers_Len = 0x45; // version 4, 5x 32bit header lnge
	ip->IP_Tos = 0x00;	// normales paket, keine spez. optionen
	ip->IP_Id = 0x00c0;	// einmalige ID. woher sollen wir die nehmen???
	ip->IP_Frag_Offset = 0x0040;	// don't fragment
	ip->IP_ttl = 64;	// max. hops
	ip->IP_Proto = PROT_TCP;	//Zeigt das hherschichtige Protokoll an 
	// --------- IP header sollte jetzt okay sein

	// !> eigene routine: create_new_tcp_header
	// neue verbindung. also seq und ack auf 0!
	buffer[TCP_ACKNUM+0] = 0;
	buffer[TCP_ACKNUM+1] = 0;
	buffer[TCP_ACKNUM+2] = 0;
	buffer[TCP_ACKNUM+3] = 0;

	buffer[TCP_SEQNUM+0] = 0;
	buffer[TCP_SEQNUM+1] = 0;
	buffer[TCP_SEQNUM+2] = 0;
	buffer[TCP_SEQNUM+3] = 0;

	buffer[TCP_HDRFLAGS+1] = FIN_FLAG; // nur damit tcp_store alles auf 0 lt!

	//Speichert Sequenzcounter und Aknowledgecounter
	tcp_store(buffer);

	//Setzen der flags
	buffer[TCP_HDRFLAGS+0] = ((20/4) << 4);; // 4bit lnge des tcp-headers in 32bit schritten, rechts davon flags
	buffer[TCP_HDRFLAGS+1] = SYN_FLAG;

	// low/high-byte entsprechend vertauscht, s. portnummern in socket.h
	buffer[TCP_SRCPORT+0]  = (SOCKET_FTPD & 0xff);
	buffer[TCP_SRCPORT+1]  = (SOCKET_FTPD >> 8);
	buffer[TCP_DESTPORT+0] = (SOCKET_FTPC & 0xff);
	buffer[TCP_DESTPORT+1] = (SOCKET_FTPC >> 8);

	buffer[TCP_WINDOW+0] = (MTU_SIZE >> 8); // MTU-size ist bestimmt nicht das gleiche wie window. aber besser als 5000 bytes!
	buffer[TCP_WINDOW+1] = (MTU_SIZE & 0xff);

	buffer[TCP_URGENTPTR+0] = 0;
	buffer[TCP_URGENTPTR+1] = 0;

	// !! hier mu ein gltiger ip header im buffer liegen, damit die berechnung hinhaut!
	tcpdata = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
	TCP_New_Packtlen(buffer, &bufferlen, tcpdata);
	
	//Erzeugt ein TCP buffer
	tcp_make(buffer);
	
	
	//Sendet das erzeugte TCP buffer
	Write_Ethernet_Frame (buffer, bufferlen);
	//printf("FTPCon\n");
}

void FTP_Push(void)
{
  cli(); ftp_connect(packet, 0);  sei();
}

#endif
